/*******************************************/
/*  main.c                                 */
/*    AX`bNNuǗvO */
/*******************************************/

#include <stdio.h>
#include <string.h>

#include "common.h"
#include "main.h"
#include "nyuukai.h"
#include "keisoku.h"
#include "sakujyo.h"

/***********************************/
/* ʃf[^                      */
/***********************************/

/* 󂫃R[h\ */
int akicode_tbl[ MEMBER_MAX + 1 ];

/* R[hEf[^Ώƕ\ */
int codedata_tbl[ MEMBER_MAX ];

/* lʌvf[^\ */
struct KEISOKU_TBL kojin_keisoku_tbl;

/*\[gpvf[^\ */
struct KEISOKU_TBL sort_keisoku_tbl[ MEMBER_MAX ];


/***********************************/
/* ǗC              */
/*   C[`                */
/*                                 */
/*   p[^ : Ȃ             */
/*   ^[   : Ȃ             */
/***********************************/
int main( void )
{
    int    loop = TRUE;                 /* [vtO                  */
    char   work[ 128 ];                 /* ̓[N                    */
    FILE   *fp;                         /* t@C|C^              */
    char   *fname1 = AKICODE_TBL_NAME;  /* 󂫃R[h\t@C          */
    char   *fname2 = CODEDATA_TBL_NAME; /* R[hEf[^Ώƕ\t@C  */
    int    i;                           /* CfbNX                  */

    /* 󂫃R[h\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname1, "rb" )) == NULL ) {
        printf( "\n 󂫃R[h\t@C쐬Ă܂" );

        /* 󂫃R[h\t@C쐬 */
        akicode_tbl_create( );
    }
    else {
        /* 󂫃R[h\t@C CLOSE */
        fclose( fp );
    }

    /* R[hEf[^Ώƕ\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname2, "rb" )) == NULL ) {
        printf( "\n R[hEf[^Ώƕ\t@C쐬Ă܂" );

        /* R[hEf[^Ώƕ\t@C쐬 */
        codedata_tbl_create( );
    }
    else {
        /* R[hEf[^Ώƕ\t@C CLOSE */
        fclose( fp );
    }

    while( loop ) {
        /* e[uNA */
        akicode_tbl[ 0 ] = 0;
        for( i = 0; i < MEMBER_MAX; i++) {
            akicode_tbl[ i + 1 ] = 0;
            codedata_tbl[ i ] = 0;
            sort_keisoku_tbl[ i ] = init_kojin_keisoku_tbl();
        }
        kojin_keisoku_tbl = init_kojin_keisoku_tbl();

        printf( "\n" );
        printf( "\n *******************************************" );
        printf( "\n  AX`bNNu o[ǗvO" );
        printf( "\n *******************************************" );
        printf( "\n IĂ" );
        printf( "\n 1:o^" );
        printf( "\n 2:vL^" );
        printf( "\n 3:o^폜" );
        printf( "\n E:I" );
        printf( "\n ? " );

        /* 敪 */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ͌`FbN -> 1ȊO ? */
        if( strlen( work ) != 1 ) {
            printf( "\n ̓~Xł" );
            continue;
        }

        switch( work[ 0 ] ) {
            case '1':       /* o^     */
                nyuukai_touroku( );
                break;

            case '2':       /* vL^ */
                keisoku_input( );
                break;

            case '3':       /* o^폜     */
                touroku_sakujyo( );
                break;

            case 'e':       /* I         */
            case 'E':
                loop = FALSE;
                break;

            default:
                printf( "\n ̓~Xł" );
                break;
        }
    }
    return OK;
}



/************************************/
/* ǗC               */
/*   󂫃R[h\@쐬         */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int akicode_tbl_create( void )
{
    int     ret;                        /* ^[R[h        */
    int     i;                          /* CfbNX          */
    FILE    *fp;                        /* t@C|C^      */
    char    *fname = AKICODE_TBL_NAME;  /* 󂫃R[h\t@C  */

    /* 󂫃R[hҏW */
    akicode_tbl[ 0 ] = MEMBER_MAX;
    for( i = 1; i < MEMBER_MAX + 1; i++ ) {
        akicode_tbl[ i ] = i;
    }

    /* 󂫃R[h\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "wb" )) == NULL ) {
        printf( "\n 󂫃R[h\t@C OPEN G[" );
        return NG;
    }

    /* 󂫃R[h\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)akicode_tbl, sizeof( akicode_tbl ), 1, fp ) )
               != 1 ) {
        printf( "\n 󂫃R[h\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* 󂫃R[h\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ǗC               */
/*   R[hEf[^Ώƕ\@쐬 */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
static int codedata_tbl_create( void )
{
    int     ret;                            /* ^[R[h                */
    FILE    *fp;                            /* t@C|C^              */
    char    *fname = CODEDATA_TBL_NAME;     /* R[hEf[^Ώƕ\t@C  */
    int     i;                              /* CfbNX                  */

    /* R[hEf[^Ώƕ\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "wb" )) == NULL ) {
        printf( "\n R[hEf[^Ώƕ\t@C OPEN G[" );
        return NG;
    }

    for( i = 0; i < MEMBER_MAX; i++ )
        codedata_tbl[ i ] = 0;

    /* R[hEf[^Ώƕ\t@C WRITE -> 1ȊO ? */
    if( (ret = fwrite( (char *)codedata_tbl, sizeof( codedata_tbl ), 1, fp ) )
               != 1 ) {
        /* WRITE G[ */
        printf( "\n R[hEf[^Ώƕ\t@C WRITE G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* R[hEf[^Ώƕ\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ʃ[`                     */
/************************************/


/************************************/
/* ʃ[`                     */
/*   󂫃R[h\@Ǎݏ       */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
int akicode_tbl_read( void )
{
    int     ret;                         /* ^[R[h         */
    int     i;                           /* CfbNX           */
    FILE    *fp;                         /* t@C|C^       */
    char    *fname = AKICODE_TBL_NAME;   /* 󂫃R[h\t@C   */

    /* 󂫃R[h\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n 󂫃R[h\t@C OPEN G[" );
        return NG;
    }

    for( i = 0; i < MEMBER_MAX + 1; i++ ) {
        /* 󂫃R[h\t@C READ -> 1ȊO ? */
        if( (ret = fread( (char *)&akicode_tbl[ i ], sizeof( int ), 1, fp ) )
                   != 1 ) {
            /* READG[ ? */
            if( ferror( fp ) != 0 ) {
                printf( "\n 󂫃R[h\t@C READ G[" );
                ret = NG;
            }
            else {
                /* t@C EOF łȂ? */
                if( feof( fp ) == 0 ) {
                    printf( "\n 󂫃R[h\t@C READ G[" );
                    ret = NG;
                }
                else {
                    ret = OK;
                }
            }
            break;
        }
    }

    /* 󂫃R[h\t@C CLOSE */
    fclose( fp );

    return ret;
}



/***********************************/
/* ʃ[`                    */
/*   smF͏              */
/*                                 */
/*   p[^ :mFbZ[W    */
/*   ^[   : 0:OK             */
/*               -1:NG             */
/***********************************/
int kakunin_input( char *msg )
{
    int     ret;            /* ^[R[h  */
    int     loop = TRUE;    /* [vtO    */
    char    work[ 128 ];    /* ̓[N      */

    while( loop ) {
        /* mF\ */
        printf( msg );
        printf( "\n ? " );

        /* Y/N */
        work[ 0 ] = '\0';
        scanf( "%s", work );

        /* ͌`FbN -> 1ȊO ? */
        if( strlen( work ) != 1 ) {
            printf( "\n ̓~Xł" );
            continue;
        }

        switch( work[ 0 ] ) {
            case 'Y':   /* Yes */
            case 'y':
                ret  = OK;
                loop = FALSE;
                break;

            case 'N':   /* No */
            case 'n':
                ret  = NG;
                loop = FALSE;
                break;

            default:
                printf( "\n ̓~Xł" );
                break;
        }
    }

    return ret;
}



/************************************/
/* ʃ[`                     */
/*   lvf[^\@Ǎݏ   */
/*                                  */
/*   p[^ : R[h        */
/*   ^[   : 0:OK              */
/*               -1:NG              */
/************************************/
int kojin_data_read( int kaiin_code )
{
    int     ret;                        /* ^[R[h                 */
    FILE    *fp;                        /* vf[^\t@C|C^   */
    long    fptr;                       /* vf[^|C^             */
    char    *fname = KEISOKU_TBL_NAME;  /* vf[^\t@C           */

    /* vf[^\t@C OPEN -> NULL ? */
    if( (fp = fopen( fname, "rb" )) == NULL ) {
        printf( "\n vf[^\t@C OPEN G[" );
        return NG;
    }

    /* Yf[^|C^Zbg */
    fptr = ( codedata_tbl[ kaiin_code - 1 ] - 1 ) *
             sizeof( struct KEISOKU_TBL );

    /* vf[^\t@CΏۂ̈ʒu܂ SEEK -> OK ? */
    if( (ret = fseek( fp, fptr, SEEK_SET )) != OK ) {
        printf( "\n vf[^\t@C SEEK G[" );

        /* vf[^\t@C CLOSE */
        fclose( fp );
        return NG;
    }

    /* vf[^\t@C READ -> 1ȊO ? */
    if( (ret = fread( (char *)&kojin_keisoku_tbl, sizeof( kojin_keisoku_tbl ),
               1, fp )) != 1 ) {
        printf( "\n vf[^\ READ G[" );
        ret = NG;
    }
    else {
        ret = OK;
    }

    /* vf[^\t@C CLOSE */
    fclose( fp );

    return ret;
}



/************************************/
/* ʃ[`                     */
/*   lvf[^@\       */
/*                                  */
/*   p[^ : R[h        */
/*                \bZ[W    */
/*   ^[   : Ȃ              */
/************************************/
void kojin_data_disp( int kaiin_code, char *msg )
{
    printf( msg );
    printf( "\n R[h %3d", kaiin_code );

    if( kojin_keisoku_tbl.count != 0 ) {
        printf( "\n\n v    t  f[^    " );
        printf( " ōt  f[^     ŐVt  f[^" );

        printf( "\n    %3d", kojin_keisoku_tbl.count );

        printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.first_date[ 0 ],
            &kojin_keisoku_tbl.first_date[ 4 ],
            &kojin_keisoku_tbl.first_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.first_data );

        printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.max_date[ 0 ],
            &kojin_keisoku_tbl.max_date[ 4 ],
            &kojin_keisoku_tbl.max_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.max_data );

        printf( "    %4.4s-%2.2s-%2.2s",
            &kojin_keisoku_tbl.soku_date[ 0 ],
            &kojin_keisoku_tbl.soku_date[ 4 ],
            &kojin_keisoku_tbl.soku_date[ 6 ] );

        printf( "   %4d", kojin_keisoku_tbl.soku_data[ 0 ] );

        printf( "\n\n    1O   2O   3O   4O   ");
        printf( "5O   6O   7O   8O   9O" );

        printf( "\n " );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 1 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 2 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 3 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 4 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 5 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 6 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 7 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 8 ] );
        printf( "    %4d", kojin_keisoku_tbl.soku_data[ 9 ] );
    }
    else {
        printf( "    vf[^܂" );
        return;
    }
    return;
}



/************************************/
/* ʃ[`                     */
/*   vf[^@         */
/*                                  */
/*   p[^ : Ȃ              */
/*   ^[   : vf[^        */
/************************************/
struct KEISOKU_TBL init_kojin_keisoku_tbl( void )
{
    static struct KEISOKU_TBL tbl = {
        0, 0, "        ", 0, "        ", 0, "        ", 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    };
    return tbl;
}
